/**
 * SAMPLE
 * 
 * @copyright   RaNa design associates, inc.
 * @author      keisuke YAMAMOTO <keisukey@ranadesign.com>
 * @link        http://kaelab.ranadesign.com/
 * @version     1.0
 * @date        2012
 *
 */
;(function($) {

	//
	// loding
	//
	var loadImg = function(_callback) {
		var count = $("img").length,
			callback = function() {
				clearTimeout(timerId);
				_callback();
			},
			timeout = 3000,
			timerId = setTimeout(function() {
				callback();
			}, timeout);

		$("img").each(function() {
			if (this.complete) {
				count--;
			} else {
				$(this).load(function() {
					if (count-- <= 1) {
						callback();
					}
				});
			}
			if (count === 0) {
				callback();
			}
		});
	};

	//
	// html.open
	//
	var openingStart = function() {
		var $html = $("html");

		$(".mod-indicator").fadeOut(200, function() {
			if (Modernizr.csstransitions) {
				$html.addClass("open");
			} else {
				// Add an indicator for convenience, changes to the # wrapper from html.
				$("#wrapper").fadeIn(400, function() {
					$(this).css("filter", "");
					$(window).trigger("resize").trigger("scroll");
				});
			}
			$(window).trigger("resize").trigger("scroll");
			$(document).trigger("shutter-nav");
		})
	};
	
	//
	// event.handle
	// In order to re-run after loading content in preload, linking to a custom event document.
	//
	$(document).on("loading", function() { // Because it does not re-run, custom event to another (loading).
		loadImg(openingStart);
	});

	//
	// main
	//
	$(function() {
		window.scrollTo(0, 0)
		$(document).trigger("loading");
	});
	
}(jQuery));
