/**
 * use keyboard
 * 
 * @copyright   RaNa design associates, inc.
 * @author      keisuke YAMAMOTO <keisukey@ranadesign.com>
 * @link        http://kaelab.ranadesign.com/
 * @version     1.0
 * @date        2012
 *
 */
;(function($) {
	
	var $navTrigger = $("nav.trigger-global");
	
	var movescrollTop = function(event) {
			// measure to shortcut key
			if (event.altKey || event.ctrlKey || event.metaKey) {
				return;
			}
			// key assignment
			switch (event.keyCode) {
				// enable scroll up
				case 33:  // page up
				case 38:  // up arrow
					scrollUp();
					event.preventDefault();
				break;
				// enable scroll down
				case 34:  // page down
				case 40:  // down arrow
					scrollDown();
					event.preventDefault();
				break;
				case 37:  // left arrow
					$navTrigger.data("isOpened") && $navTrigger.click();
					event.preventDefault();
				break;
				case 39:  // right arrow
					!$navTrigger.data("isOpened") && $navTrigger.click();
					event.preventDefault();
				break;
			}
		},
		scrollUp = function() {
			var scrollTop = $(window).scrollTop(),
				_h = $(window).height() * 0.4 | 0;

			if ($.pages.active > 0 && scrollTop === $.pages[$.pages.active]) {
				if ($.section.eq($.pages.active - 1).hasClass("cover")) {
					scrollAnimate($.pages[$.pages.active - 1], true);
					return;
				}
			} else if ($.section.eq($.pages.active).hasClass("cover")) {
				scrollAnimate($.pages[$.pages.active] - 1, true);
				return;
			}
			scrollAnimate(scrollTop - Math.min(_h, scrollTop - $.pages[$.pages.active]) - 1);
		},
		scrollDown = function() {
			var scrollTop = $(window).scrollTop(),
				_h = $(window).height() * 0.4 | 0;

			if ($.pages.active < $.pages.length - 1) {
				if ($.section.eq($.pages.active).hasClass("cover") ) {
					scrollAnimate($.pages[$.pages.active + 1], true);
				} else {
					scrollAnimate(scrollTop + Math.min(_h, $.pages[$.pages.active + 1] - scrollTop));
				}
			} else {
				scrollAnimate(scrollTop + _h);
			}
		},
		scrollAnimate = function(y, isCover) {
			var isEnd = false,
				d = Math.abs(y - $(window).scrollTop());
			// ms, moz: html, webkit: body
			$("html, body").stop(true).animate({
				scrollTop: y
			}, {
				easing: isCover ? "easeOutQuad" : "easeOutCubic",
				duration: isCover ? d : d * 3,
				complete: function() {
					if (!isEnd) {
						isEnd = true;
						$(window).trigger("scroll");
					}
				}
			});
		};
	
	var onmousewheel = function(event) {
		var _event = event.originalEvent || window.event,
			delta = 0;

		// Standardization of the amount of movement.
		if (_event.wheelDelta) {
			delta = _event.wheelDelta / -120;
		} else if (_event.detail) {
			delta = _event.detail / 3;
		}
		// Content movement.
		if (delta < 0) {
			scrollUp();
		} else if (delta > 0) {
			scrollDown();
		}
		event.preventDefault();  // overflow: the case of the scroll / auto, you do not listen to scroll.
	};
	
	$(document).on("keydown", movescrollTop);

	// Taking advantage of the Mac it is the default wheel so pleasant.
	if (!/MacIntel/i.test(navigator.platform)) {
		$(document).on("DOMMouseScroll mousewheel", onmousewheel);
	}

}(jQuery));

