/**
 * navigation to open shutter
 * 
 * @copyright   RaNa design associates, inc.
 * @author      keisuke YAMAMOTO <keisukey@ranadesign.com>
 * @link        http://kaelab.ranadesign.com/
 * @version     1.0
 * @date        2012
 *
 */
;(function($) {

	$.section = $.section || $("section");

	var $stage = $("#area-stage"),
		$navTrigger = $("nav.trigger-global"),
		$navGlobal = $("nav.global"),
		isOpened = false;

	var slideToggle = function(event, callback) {
		var _$modules = $.section.add($navTrigger).add($stage);
			_navWidth = $navGlobal.width(),
			_isSlide = true,
			_slideSpeed = 400;
		
		setOffsetY();
		$navGlobal.css({ zIndex: -999 });
		_$modules.stop(true).animate({
			marginLeft: isOpened ? 0 : _navWidth
		}, {
			duration: _slideSpeed,
			complete: function() {
				// one time callback
				if (_isSlide) {
					_isSlide = false;
					if (isOpened ^= true) {
						// activate the links
						$navGlobal.css({ zIndex: 999 });
					}
					$navTrigger.data("isOpened", isOpened);
					typeof callback === "function" && callback();
				}
			}
		});
		event.preventDefault();
	};
	
	var togglePosition = function(event) {
		$navGlobal.css({
			position: $(window).height() < $navGlobal.outerHeight() ? "absolute" : "fixed"
		});
		setOffsetY();
		event.preventDefault();
	};
	
	// set nav top position
	var setOffsetY = function() {
		if (!isOpened) {
			$navGlobal.css({ top: $(window).height() < $navGlobal.outerHeight() ? $(window).scrollTop() : 0 });
		}
	};
	
	//
	// guide navigation
	//
	var navGuide = function() {
		var timerId = 0;
		if ($("body").hasClass("home")) {
			$navTrigger.click();
		} else if ($(window).scrollTop() === 0) {
			timerId = setTimeout(function() {
				$navTrigger.click();
			}, 2000);
			$navTrigger.click();
			// prevent pressing twice
			$navTrigger.one("click", function() {
				clearTimeout(timerId);
			});
		}
	};

	//
	// event.handle
	//
	$navTrigger.on("click", slideToggle);
	$(window).on("resize", togglePosition);
	$(document).on("shutter-nav", navGuide);

}(jQuery));
