/**
 * shutter
 * 
 * @copyright   RaNa design associates, inc.
 * @author      keisuke YAMAMOTO <keisukey@ranadesign.com>
 * @link        http://kaelab.ranadesign.com/
 * @version     1.0
 * @date        2012
 *
 */
;(function($) {

	$.pages = $.pages || [];

	var $body = $("body");

	//
	// init pages for PC
	// reset: true => initialize element
	//
	var initPages = function() {
		var _height = 0,
			_windowWidth = $(window).width(),
			_windowHeight = $(window).height();
		// pages data
		$.pages = [];
		//$.pages.active = 0;  // used by shutter-key
		$.section = $("section");
		$.coverImg = $.section.filter(".cover").find("> img");
		// fit covered pages
		$.coverImg.css({ minHeight: _windowHeight });
		$.coverImg.css({ marginLeft: _windowWidth < $.coverImg.width() ? (_windowWidth - $.coverImg.width()) / 2 : 0 });  // centering
		// each pages
		$.section.each(function(i) {
			$.pages.push(_height);
			// data-pageY
			$(this).data({ pageY: _height })
			_height += $(this).outerHeight();
			// z-index
  			$(this).css({ zIndex: $.section.length - i });
		});
		// set body.height == set scroll bar
		$body.height(_height);
		// resize bug fix
		window.scrollTo(0, 0);
	};

	//
	// page transition
	// move page and set page number
	//	
	var shutterScroll = function() {
		if ($.disableShutter) {
			return false;
		}
		// get scrollTop
		var scrollTop = $(window).scrollTop(),
			scrollLeft = $(window).scrollLeft();  // Ban for horizontal scrolling.
		// Ban horizontal scrolling.
		// prevent horizontal scroll
		if (scrollLeft) {
			window.scrollTo(0, scrollTop);
		}
		// each pages
		$.section.each(function() {
			if ($(this).data("pageY") < scrollTop) {
				// or use data-end for range
				if ($(this).css("position") === "fixed") {
					$(this).css({ top: $(this).data("pageY") });
				}
				$(this).css({ position: "absolute" });
			} else {
				// reset
				$(this).css({ position: "fixed", top: 0 });
			}
		});
		// used by shutter-key
		// setPageNumber(scrollTop);
	};
	
	//
	// set active page number
	//
	var setPageNumber = function(y) {
		var i = $.pages.length;
		while (i--) {
			if ($.pages[i] <= y) {
				$.pages.active = i;
				break;
			}
		}
	};

	//
	// event handling
	//
	$(window).on("resize", initPages);
	$(window).on("scroll", shutterScroll);

}(jQuery));

